#!/bin/bash 
N_COLORS=${1}
N_DIMS=${2}

source env_quda.sh ${N_COLORS} ${N_DIMS} 
echo "echo Nc"
echo ${N_COLORS}

# Pull QUDA
rm -rf ${SRCDIR}/quda
git clone https://github.com/lattice/quda.git ${SRCDIR}/quda
(cd ${SRCDIR}/quda; git checkout feature/Nc_ag_slaph)

rm -rf ${BUILDDIR}/quda
rm -rf ${INSTALLDIR}/quda

pushd ${BUILDDIR}
mkdir ./quda

pushd ./quda

#Fermions
QUDA_DIRAC_WILSON=ON
QUDA_DIRAC_CLOVER=ON
QUDA_DIRAC_CLOVER_HASENBUSCH=OFF
QUDA_DIRAC_TWISTED_MASS=OFF
QUDA_DIRAC_TWISTED_CLOVER=OFF
QUDA_DIRAC_NDEG_TWISTED_MASS=OFF
QUDA_DIRAC_STAGGERED=ON
QUDA_DIRAC_DOMAIN_WALL=OFF

#Extras
QUDA_FAST_COMPILE_DSLASH=OFF
QUDA_FAST_COMPILE_REDUCE=OFF
QUDA_FLOAT8=ON
QUDA_MULTIGRID=NO
QUDA_BUILD_SHAREDLIB=ON
QUDA_GPU_ARCH="sm_70"
QUDA_BUILD_ALL_TESTS=ON
QUDA_INSTALL_ALL_TESTS=ON
QUDA_INTERFACE_QDPJIT=ON
QUDA_CONTRACT=OFF
QUDA_LAPLACE=ON

QUDA_BLAS_3D=ON

#Precisons enabled.
# Expressed in base 10 as a number from 1-15,
# interpreted as base 2: (double,single,half,quarter)
# eg, 14 -> (1,1,1,0)
#      4 -> (0,1,0,0)
QUDA_PRECISION=14

#IO and MPI
QUDA_QIO=ON
QUDA_QMP=ON
QUDA_MPI=OFF
QUDA_DOWNLOAD_USQCD=ON

QUDA_N_COLORS=${N_COLORS}
QUDA_RECONSTRUCT=4
QUDA_CXX_STANDARD=14    

CMFLAGS="-DCMAKE_INSTALL_PREFIX:PATH=${INSTALLDIR}/quda \
-DQUDA_BUILD_ALL_TESTS=${QUDA_BUILD_ALL_TESTS} \
-DQUDA_INSTALL_ALL_TESTS=${QUDA_INSTALL_ALL_TESTS} \
-DQUDA_DIRAC_WILSON=${QUDA_DIRAC_WILSON} \
-DQUDA_DIRAC_CLOVER=${QUDA_DIRAC_CLOVER} \
-DQUDA_DIRAC_TWISTED_MASS=${QUDA_DIRAC_TWISTED_MASS} \
-DQUDA_DIRAC_NDEG_TWISTED_MASS=${QUDA_DIRAC_NDEG_TWISTED_MASS} \
-DQUDA_DIRAC_TWISTED_CLOVER=${QUDA_DIRAC_TWISTED_CLOVER} \
-DQUDA_DIRAC_CLOVER_HASENBUSCH=${QUDA_DIRAC_CLOVER_HASENBUSCH} \
-DQUDA_DIRAC_STAGGERED=${QUDA_DIRAC_STAGGERED} \
-DQUDA_DIRAC_DOMAIN_WALL=${QUDA_DIRAC_DOMAIN_WALL} \
-DQUDA_FAST_COMPILE_DSLASH=${QUDA_FAST_COMPILE_DSLASH} \
-DQUDA_FAST_COMPILE_REDUCE=${QUDA_FAST_COMPILE_REDUCE} \
-DQUDA_CONTRACT=${QUDA_CONTRACT} \
-DQUDA_LAPLACE=${QUDA_LAPLACE} \
-DQUDA_BUILD_SHAREDLIB=${QUDA_BUILD_SHAREDLIB} \
-DQUDA_FLOAT8=${QUDA_FLOAT8} \
-DQUDA_GPU_ARCH=${QUDA_GPU_ARCH} \
-DQUDA_PRECISION=${QUDA_PRECISION} \
-DQUDA_BLAS_3D=${QUDA_BLAS_3D} \
-DQUDA_DOWNLOAD_USQCD=${QUDA_DOWNLOAD_USQCD} \
-DQUDA_QMP=${QUDA_QMP}	\
-DQUDA_MPI=${QUDA_MPI} \
-DQUDA_QIO=${QUDA_QIO} \
-DQUDA_MULTIGRID=${QUDA_MULTIGRID} \
-DQUDA_RECONSTRUCT=${QUDA_RECONSTRUCT} \
-DQUDA_INTERFACE_QDPJIT=${QUDA_INTERFACE_QDPJIT} \
-DQUDA_N_COLORS=${QUDA_N_COLORS} \
-DQUDA_CXX_STANDARD=${QUDA_CXX_STANDARD} "

cmake ${CMFLAGS} ${SRCDIR}/quda
make -j install 
popd
popd

QUDA_CMAKE_DIR="${INSTALLDIR}/quda/lib/cmake/QUDA"

